var $ = require("cheerio");
var request = require('request');
var agent = require("socks5-http-client/lib/Agent");
var fs = require('fs');
var ListHandler = require('./listhandler.js');
var ComicHandler = require('./comichandler.js');

require('./config.js');


var loadCategory = 12;

var CheckLibsTimer = setInterval(checkLibs,1000);
setInterval(function(){},1000000);
// getCategories(getList);
function getCategories(callback){
    var options = {
        url:ApiURL.category
        // agentClass:agent,
        // agentOption:{
        //     socksHost:'127.0.0.1',
        //     socksPort:1080
        // }
    };
    request(options,function(error,response,body){
        if(!error && body){
            var oldData = JSON.parse(body);
            for(var i in oldData){
                var ListObj = oldData[i];
                CategoryLib[ListObj.id] = {
                    id:ListObj.id,
                    name:ListObj.name,
                    length:ListObj.all_comics
                };
            }
            fs.writeFileSync('./temp/Category.json',JSON.stringify(CategoryLib),'UTF-8');
            if(callback){
                callback.call(this);
            }
        }
    });
}

function getList(){
    new ListHandler(12,1);
}


getTempLib();
function getTempLib(){
    var data;
    if(fs.existsSync('./temp/Category.json')){
        data = fs.readFileSync('./temp/Category.json');
        CategoryLib = JSON.parse(data);
    }else{
        getCategories();
    }
    if(fs.existsSync('./temp/Category_'+loadCategory+'.json')){
        data = fs.readFileSync('./temp/Category_'+loadCategory+'.json');
        ListLib = JSON.parse(data);
    }else{
        new ListHandler(loadCategory);
    }
}

function checkLibs(){
    if(CategoryLib && ListLib){
        clearInterval(CheckLibsTimer);
        ComicHandler.start();
    }
}

